#! /bin/bash

PACKAGE_NAME="printer-driver-deepinwine-lenovom3410"
PACKAGE_VERSION="0.1.0"
PRINTER_NAME=( "Lenovo M3410 Printer" "Lenovo M3420 Printer" )

CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
OPT_PATH="/opt/deepinwine/printer_drv/$PACKAGE_NAME"
WINEBIN="deepin-wine"
REGDIR="reg"
FILEDIR="files"

if [ -z "$PACKAGE_NAME" -o ! -d "$OPT_PATH" ]; then
    exit 1
fi

if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ -f "$CONTAINER_PATH/VERSION" ] && [ "$(cat "$CONTAINER_PATH/VERSION")" = "$PACKAGE_VERSION" ]; then
        exit 0
    fi

    rm -rf "$CONTAINER_PATH"
fi

if [ -d "$OPT_PATH/$REGDIR" ]; then
    for file in $OPT_PATH/$REGDIR/*; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

if [ -d "$OPT_PATH/$FILEDIR" ]; then
    for file in `find "$OPT_PATH/$FILEDIR" -type f`; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp "$file" "$path"
    done
fi

WININI="$CONTAINER_PATH/drive_c/windows/win.ini"
if [ -f "$WININI" ]; then
    for name in "${PRINTER_NAME[@]}"; do
        grep -q "^\[devices\]" "$WININI" || sed -ie "$ a [devices]" "$WININI"
        grep -q "^\[PrinterPorts\]" "$WININI" || sed -ie "$ a [PrinterPorts]" "$WININI"
        sed -ie "/^\[devices\]/a $name=winerp.drv,USB" "$WININI"
        sed -ie "/^\[PrinterPorts\]/a $name=winerp.drv,USB,15,45" "$WININI"
    done
fi

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"
